
#include "LCD_2x16_74HC595.h"
#include "gpio.h"

#define LCD_SCK     GPIO_PIN_7     
#define LCD_DI      GPIO_PIN_6    
#define LCD_LCK     GPIO_PIN_5


unsigned char data_value;


void SIPO()
{
    unsigned char clk = 8;
    unsigned char temp = 0;

    temp = data_value;
    //LCD_LCK = 0;
	  HAL_GPIO_WritePin(GPIOA, LCD_LCK , GPIO_PIN_RESET);
    while(clk > 0)
    {
       // LCD_DI = ((temp & 0x80) >> 0x07);
			  HAL_GPIO_WritePin(GPIOA, LCD_DI, !!(((temp & 0x80) >> 0x07))? GPIO_PIN_SET : GPIO_PIN_RESET);
        //LCD_SCK = 1;
			  HAL_GPIO_WritePin(GPIOA, LCD_SCK , GPIO_PIN_SET);
        temp <<= 1;
			  //  LCD_SCK = 0;
        HAL_GPIO_WritePin(GPIOA, LCD_SCK , GPIO_PIN_RESET);
        clk--;
    }
   // LCD_LCK = 1;
		HAL_GPIO_WritePin(GPIOA, LCD_LCK , GPIO_PIN_SET);
}


void LCD_Init_74HC595()
{   
    unsigned char t = 0x0A;
    data_value = 0x08;
    SIPO();
    while(t > 0x00)
    {
     HAL_Delay(dly);
      t--;
    };

    data_value = 0x30;
    SIPO();

    data_value |= 0x08;
    SIPO();
    HAL_Delay(dly);
    data_value &= 0xF7;
    SIPO();
    HAL_Delay(dly);

    data_value = 0x30;
    SIPO();

    data_value |= 0x08;
    SIPO();
    HAL_Delay(dly);
    data_value &= 0xF7;
    SIPO();
    HAL_Delay(dly);

    data_value = 0x30;
    SIPO();

    data_value |= 0x08;
    SIPO();
    HAL_Delay(dly);
    data_value &= 0xF7;
    SIPO();
    HAL_Delay(dly);

    data_value = 0x20;
    SIPO();

    data_value |= 0x08;
    SIPO();
    HAL_Delay(dly);
    data_value &= 0xF7;
    SIPO();
    HAL_Delay(dly);
    
    LCD_command(_4_pin_interface | _2_row_display | _5x7_dots);
    LCD_command(display_on | cursor_off | blink_off);
    LCD_command(clear_lcd);
    LCD_command(cursor_direction_inc | display_no_shift);
}


void LCD_command(unsigned char value)
{
    data_value &= 0xFB;
    SIPO();
    LCD_4bit_send(value);
}

void LCD_clear_home()
{
   LCD_command(clear_lcd);
   LCD_command(goto_home);
}

void LCD_send_data(unsigned char value)
{
    data_value |= 0x04;
    SIPO();
    LCD_4bit_send(value);
}


void LCD_4bit_send(unsigned char lcd_data)
{
    unsigned char temp = 0x00;

    temp = (lcd_data & 0xF0);
    data_value &= 0x0F;
    data_value |= temp;
    SIPO();

    data_value |= 0x08;
    SIPO();
    HAL_Delay(dly);
    data_value &= 0xF7;
    SIPO();
    HAL_Delay(dly);

    temp = (lcd_data & 0x0F);
    temp <<= 0x04;
    data_value &= 0x0F;
    data_value |= temp;
    SIPO();

    data_value |= 0x08;
    SIPO();
    HAL_Delay(dly);
    data_value &= 0xF7;
    SIPO();
    HAL_Delay(dly);
}


void LCD_Print(unsigned char y_pos,unsigned char x_pos, char *lcd_string)
{
    if((y_pos-1) == 0)
    {
        LCD_command(0x80 | (x_pos-1));
    }
    else
    {
        LCD_command(0x80 | 0x40 | (x_pos-1));
    }

    while (*lcd_string != '\0')
    {
        LCD_send_data(*lcd_string);
        lcd_string++;
    };
}


void LCD_Print_Chr(unsigned char y_pos,unsigned char x_pos, char char_data)
{
    if((y_pos-1) == 0)
    {
        LCD_command(0x80 | (x_pos-1));
    }
    else
    {
        LCD_command(0x80 | 0x40 | (x_pos-1));
    }
    LCD_send_data(char_data);
}
